// bitcompl.cpp : demonstracija bitovnog komplenta

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 2.4.11 Bitovni operatori
// bitovni komplement

#include <iostream>
using namespace std;

int main() {

	// bitovni komplement
	unsigned char a = 0x25;			// 00100101 u heksadek.prikazu
	unsigned char b = ~a;			// pridrui bitovni komplement

	cout << hex << (int)a << endl;	// ispisuje a u hex-formatu
	cout << (int)b << endl;			// ispisuje b u hex-formatu

	int maska = 0x000f;
	// bitovni i
	cout << (a & maska) << endl;	// ispisuje 0x5

	// bitovni ili
	cout << (a | maska) << endl;	// ispisuje 0x2f

	// bitovni iskljuivi ili
	cout << (a ^ maska) << endl;	// ispisuje 0x2a

	a = 20;
	// pomak za 1 bit ulijevo
	cout << dec << (a << 1) << endl;// ispisuje 40
									// dec aktivira dekadski format
	// pomak za 2 bita udesno
	cout << (a >> 2) << endl;		// ispisuje 5

	char x;
	cin >> x;
	return 0;
}
