// bubblesort.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 4.1.1 Jednodimenzionalna polja
// Sortiranje jednodimenzionalnog polja mjehuriastim postupkom

#include <iostream>
#include <fstream>
using namespace std;

int main() {
	const int nmax = 100;
	float x[nmax];
	ifstream ulazniTok("brojevi.dat");

	if (!ulazniTok) {
		cerr << "Ne mogu otvoriti traenu datoteku" 
			 << endl;
		return 1;
	}
	int n=-1;
	while (!ulazniTok.eof()) {		// prekida se na kraju datoteke
		if (n >= nmax) {
			cerr << "Previe podataka!" << endl;
			return 2;
		}
		ulazniTok >> x[++n];
	}
	if (n < 0) {
		cerr << "Nema podataka!" << endl;
		return 3;
	}
	for (int i = n-1; i > 0; i--) {
		bool zamjena = false;
		for (int j = 0; j < i; j++) {
			if (x[j+1] < x[j]) {
				float priv = x[j];
				x[j] = x [j+1];
				x[j+1] = priv;
				zamjena = true;
			}
		}
		if (zamjena==false)
			break;
	}
    cout << "Brojevi sloeni po veliini:" << endl;
	for (int i = 0; i < n; i++) 
		cout << x[i] << endl;

	char z;
	cin >> z;
	return 0;

}