// newpolje.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 4.2.6 Dinamiko alociranje polja
// Primjer dinamikog alociranja polja

#include <iostream>
using namespace std;

int main() {
	cout << "Koliko toaka mogu oekivati efe? ";
	int n;						// broj toaka
	cin >> n;

	float *x = new float[n];	// alocira se prostor za
	float *y = new float[n];	// polja s koordinatama

	double srednjiX = 0.0;		// srednja vrijednost od x
	double srednjiY = 0.0;		// srednja vrijednost od y
	cout << "Upii koordinate!" << endl;
	for (int i = 0; i < n; i++) {
		cout << "t(" << i+1 << ") = ";
		cin >> x[i];
		cout << "s(" << i+1 << ") = ";
		cin >> y[i];
		srednjiX += x[i];
		srednjiY += y[i];
	}
	srednjiX /= n;
	srednjiY /= n;
	double a = 0.0;				// koeficijent smjera
	double nazivnik = 0.0;		// nazivnik izraza za k.s.
	for (int i = 0; i < n; i++) {
		double deltaX = x[i] - srednjiX;
		a += deltaX * y[i];
		nazivnik += deltaX * deltaX;
	}
	a /= nazivnik;
	double b = srednjiY - a * srednjiX;
	delete [] x;				// oslobaamo prostor
	delete [] y;

	cout << "Prosjena brzina trkaa je " 
		 << a << " m/s" << endl;
	cout << "Ako bude jednako uporan, za 800 metara " 
		 << "trebat e mu oko " << (800 - b) / a
		 << " sekundi." << endl;

	char z;
	cin >> z;
	return 0;

}

