// neodredj.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 5.4.8 Funkcije s neodreenim argumentima
// 

#include <iostream>
#include <cstdarg>
using namespace std;

int spikaNaSpiku(char *format, ...) {
	va_list vl;					// podatak tipa va_list
	va_start(vl, format);		// inicijalizira vl

	int i = 0;
	while (*(format + i)) {
		if (*(format + i) == '%') {
			switch (*(format + (++i)++)) {
			  case 'd':
			  case 'i': {
				int br = va_arg(vl, int);
				cout << br;
				break;
			  }
			  case 's': {
				char *zn_niz = va_arg(vl, char*);
				cout << zn_niz;
				break;
			  }
			  case 'c': {
				char zn = va_arg(vl, char);
				cout << zn;
				break;
			  }
			  default:
				cerr << endl 
					 << "Nedefinirani tip podataka! " 
					 << endl;
				va_end(vl);
				return 0;
			}
		}
		else
			cout << (*(format + i++));
	};
	va_end(vl);
	return 1;
}


int main() {
	spikaNaSpiku("Pa znam da je %i + %d jednako %s!", 1, 2, "pet");

	char z;
	cin >> z;
	return 0;
}