// racunaj.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 5.11 Funkcija main()
// Program za jednostavne aritmetike operacije na
// dva broja zadana kao parametri pri pozivu programa

#include <iostream>
#include <cstdlib>
using namespace std;

int main(int argc, char* argv[]) {
	if (argc < 4) {
		cerr << "Nedovoljno parametara!" << endl;
		return 1;
	}
	float operand1 = atof(argv[1]);
	char operacija = *argv[2];
	float operand2 = atof(argv[3]);
	switch (operacija) {
	  case('+'):
		cout << (operand1 + operand2) << endl;
		break;
	  case('-'):
		cout << (operand1 - operand2) << endl;
		break;
	  case('*'):
		cout << (operand1 * operand2) << endl;
		break;
	  case('/'):
		cout << (operand1 / operand2) << endl;
		break;
	  default:
		cerr << "Nepoznati operator " << operacija << endl;
		return 1;
	}
	return 0;
}
