// strcmp.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 5.12.1 Funkcije za rukovanje znakovnim nizovima
// Primjer funkcija strcmp i strcoll

#include <iostream>
#include <cstring>
#include <cctype>
using namespace std;

char *umalo(char *niz) {
	char *zn = niz;
	while (*zn) {
		*zn = tolower(*zn);
		zn++;
	}
	return niz;
}

int main() {
	char *prvi = "mama";
	char *drugi = "Tata";
	int usporedba = strcmp(prvi, drugi);
	if (usporedba) {
		if (usporedba > 0)
			cout << "\"" << prvi  << "\" je vei od \""
				 << drugi << "\"" << endl;
		else
			cout << "\"" << drugi << "\" je vei od \""
				 << prvi << "\"" << endl;
	}
	else
		cout << " \"" << prvi << "\" i \"" << drugi
			 << "\" su jednaki" << endl;

	cout << "Nakon pretvorbe velikih u mala slova:" << endl;

//	strlwr(drugi);		// NESTANDARDNA FUNKCIJA!
	umalo(drugi);
	usporedba = strcmp(prvi, drugi);
	if (usporedba) {
		if (usporedba > 0)
			cout << "\"" << prvi  << "\" je vei od \""
				 << drugi << "\"" << endl;
		else
			cout << "\"" << drugi << "\" je vei od \""
				 << prvi << "\"" << endl;
	}
	else
		cout << " \"" << prvi << "\" i \"" << drugi
			 << "\" su jednaki" << endl;

	setlocale( LC_ALL, "Croatian" );
	char *treci = "aa";
	usporedba = strcoll(drugi, treci);
	if (usporedba) {
		if (usporedba > 0)
			cout << "\"" << drugi  << "\" je vei od \""
				 << treci << "\"" << endl;
		else
			cout << "\"" << treci << "\" je vei od \""
				 << drugi << "\"" << endl;
	}
	else
		cout << " \"" << drugi << "\" i \"" << treci
			 << "\" su jednaki" << endl;

	char *cetvrti = "caca";
	usporedba = strcoll(treci, cetvrti);
	if (usporedba) {
		if (usporedba > 0)
			cout << "\"" << treci  << "\" je vei od \""
				 << cetvrti << "\"" << endl;
		else
			cout << "\"" << cetvrti << "\" je vei od \""
				 << treci << "\"" << endl;
	}
	else
		cout << " \"" << treci << "\" i \"" << cetvrti
			 << "\" su jednaki" << endl;

	char z;
	cin >> z;
	return 0;
}
