// volimenevoli.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 5.6.3 Statiki objekti u funkcijama
// Primjer sa statikim objektom u funkciji

#include <iostream>
#include <cstdlib>
#include <ctime>
using namespace std;

void VoliMeNeVoli() {
	static bool VoliMe = false;			// statiki objekt
	VoliMe = !VoliMe;
	if (VoliMe)
		cout << "Voli me!" << endl;
	else
		cout << "Ne voli!" << endl;
}

int main() {
	srand(time(NULL));
	int i = rand() % 10 + 1;	// sluajni broj od 1 do 10
	while (i--)
		VoliMeNeVoli();

	char z;
	cin >> z;
	return 0;
}
