// vektor0.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 6.13 Privremeni objekti
// Klasa Vektor i ispis prilikom stvaranja i unitavanja
// privremenih objekata

#include <iostream>
using namespace std;

class Vektor {
friend void ZbrojiVektore(Vektor &a, Vektor &b,
						  Vektor &rez);
private:
	double ax, ay;
public:
	Vektor(double x = 0, double y = 0) : ax(x), ay(y) {}
	double DajX() { return ax; }
	double DajY() { return ay; }
	void PostaviXY(double x, double y) { ax = x; ay = y; }
};

void ZbrojiVektore(Vektor &a, Vektor &b, Vektor &rez) {
	rez.ax = a.ax + b.ax;
	rez.ay = a.ay + b.ay;
}

int main() {

	Vektor a(10.0, 2.8);
	Vektor b(-2.0, 5.0);
	Vektor c;

	ZbrojiVektore(a, b, c);

	cout << "<" << c.DajX() << ", " << c.DajY() << ">" << endl;

	char z;
	cin >> z;
	return 0;
}