// vektor2.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 6.13.2 Privremeni objekti
// Klasa Vektor 

#include <iostream>
using namespace std;

class Vektor {
private:
	static int brojac;
	int redbr;
	double ax, ay;
public:
	Vektor(const Vektor &ref);
	Vektor(double a, double b);
	~Vektor();
	void PostaviXY(double x, double y) { ax = x; ay = y; }
};

Vektor::Vektor(const Vektor &ref) :
			ax(ref.ax), ay(ref.ay), redbr(++brojac) {
	cout << "Stvoren vektor pomou konstruktora kopije "
		 << "pod brojem " << redbr << endl
		 << "X: " << ax << "    Y: " << ay << endl;
}

void NaNulu(Vektor v) {
	cout << "Uao u NaNulu" << endl;
	v.PostaviXY(0, 0);
	cout << "Postavio sam" << endl;
}

int Vektor::brojac = 0;

Vektor::Vektor(double x, double y) :
		ax(x), ay(y), redbr(++brojac) {
	cout << "Stvoren vektor pod brojem " << redbr << endl;
	cout << "X: " << ax << "    Y: " << ay << endl;
}

Vektor::~Vektor() {
	cout << "Uniten vektor pod brojem " << redbr << endl;
	cout << "X: " << ax << "    Y: " << ay << endl;
}

int main() {
 	cout << "Uao sam u main" << endl;
	cout << "Pozivam NaNulu" << endl;
	NaNulu(Vektor(12, 3));
	cout << "Zavravam" << endl;

	char z;
	cin >> z;
	return 0;
}
