// kompleksni.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 8.3. Definicija operatorske funkcije


class Kompleksni {
friend Kompleksni operator-(const Kompleksni &l,
							const Kompleksni &d);
private:
	float real, imag;
public:
	Kompleksni(float r = 0, float i = 0) :
			real(r), imag(i) {}
	Kompleksni operator+(const Kompleksni &d);
};

Kompleksni Kompleksni::operator+(const Kompleksni &d) {
	return Kompleksni(real + d.real, imag + d.imag);
}

Kompleksni operator-(const Kompleksni &l,
					 const Kompleksni &d) {
	return Kompleksni(l.real + d.real, l.imag + d.imag);
}


int main() {
	Kompleksni a, b;
	b = 5 + a; // pogreka: 5 se ne konvertira u Kompleksni
	b = a + 5;
	b = 5 - a; // OK: 5 se konvertira u Kompleksni
	return 0;
}
