// matrica.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 8.3.2. Operator []


class Matrica {
private:
	float *mat;
	int redaka, stupaca;

	class Pristupnik {
	public:
		int prvadim, stupaca;
		float *mat;
		Pristupnik(int pd, int st, float *mt) :
			prvadim(pd), stupaca(st), mat(mt) {}
		float& operator[](int drugadim) { 
			return mat[prvadim * stupaca + drugadim];
		}
	};

public:
	Matrica(int red, int stu);
	~Matrica() { delete [] mat; }
	Pristupnik operator[](int prvadim) {
		return Pristupnik(prvadim, stupaca, mat);
	}
};

Matrica::Matrica(int red, int stu) : redaka(red),
		stupaca(stu), mat(new float[red * stu]) {}
