// razlucivanjekonverzije2.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 8.1.3. Operatori konverzije

#include <iostream>
#include <cstring>
using namespace std;

class ZnakovniNiz {
private:
	char *pokNiz;

public:
	ZnakovniNiz(char *niz = "");
	operator char*() { return pokNiz; };
};


ZnakovniNiz::ZnakovniNiz(char *niz) : pokNiz(new char[strlen(niz) + 1]) {
	strcpy(pokNiz, niz);
}


class Identifikator {
private:
	int indeks;
	ZnakovniNiz naziv;

public:
	Identifikator(int ind, const ZnakovniNiz &ref) :
		indeks(ind), naziv(ref) { }

	const ZnakovniNiz &DajNiz() const { return naziv; }
	operator int() { return indeks; }
	operator ZnakovniNiz() { return naziv; }
//	treba dodati ovaj operator da bi poziv funkcije PisiZnakovniNiz radio:
//	operator char*() { return naziv; }
};


void PisiZnakovniNiz(char *niz) {
	cout << niz;
}

int main() {
	Identifikator a(5, ZnakovniNiz("Nema konverzije"));
	PisiZnakovniNiz(a);		// pogreka

	ZnakovniNiz pobjednikNaLutriji = "Janko";
	char *pokNiz = pobjednikNaLutriji; 
	// gornja naredba provodi implicitnu konverziju tako da
	// vraa pokaziva na implementaciju
	*pokNiz = 'R'; // pobjednik postaje Ranko

	return 0;
}
