// xyz.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 8.3.4. Operator ->

#include <iostream>
using namespace std;

class Z {
public:
	int clan;
	Z(int mm) : clan(mm) {}
};


class Y {
public:
	Z &referencaNaZ;
	int clan;
	Y(Z &rz, int mm) : referencaNaZ(rz), clan(mm) {}
	Z *operator ->() {
		cout << "Pozvan oeprator -> od Y" << endl;
		return &referencaNaZ;
	}
};

class X {
public:
	Y &referencaNaY;
	int clan;
	X(Y &ry, int mm) : referencaNaY(ry), clan(mm) {}
	Y& operator ->() {
		cout << "Pozvan operator -> od X" << endl;
		return referencaNaY;
	}
};

int main() {
	Z objZ(1);
	Y objY(objZ, 2);
	X objX(objY, 3);
	cout << "lan: " << objX->clan;
	return 0;
}
