// znakovniniz2.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 8.1.2 Eksplicitni konstruktori
// Primjer eksplicitnog konstruktora

#include <cstring>
using namespace std;

class ZnakovniNiz {
private:
	char *pokNiz;
public:
	explicit ZnakovniNiz(int n);	// eksplicitni konstr.
	ZnakovniNiz(char *niz = "");	// "obini" konstruktor
};

ZnakovniNiz:: ZnakovniNiz(int n) : pokNiz(new char[n + 1]) {
}

ZnakovniNiz::ZnakovniNiz(char *niz) : pokNiz(new char[strlen(niz) + 1]) {
	strcpy(pokNiz,niz);
}


char *pZnak(ZnakovniNiz);

ZnakovniNiz smutljivac() {
	pZnak(15);			// pogreka: nema implicitne 
						// pretvorbe int u ZnakovniNiz
	pZnak("jalnuki diletant");
						// OK: pZnak(ZnakovniNiz("jal.."))
	return 10;			// pogreka: nema int u ZnakovniNiz
}
