//  grafobjekt.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 9.11.2. Poziv virtualnih funkcijskih lanova

enum TBoja {BIJELA, CRVENA, PLAVA, ZELENA, CRNA};

class GrafObjekt {
private:
	TBoja Boja;
public:
	void PostaviBoju(TBoja nova) { Boja = nova; }
	TBoja CitajBoju() { return Boja; }
	virtual void Crtaj() {}
	virtual void Brisi() {}
	virtual void Translatiraj(int, int) {}
	void Pomakni(int px, int py);
};

void GrafObjekt::Pomakni(int px, int py) {
	Brisi();
	Translatiraj(px, py);
	Crtaj();
}


