//  vektor.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 9.4.3. Privatne osnovne klase

class Vektor {
private:
	float ax, ay;
public:
	Vektor(float a = 0, float b = 0) : ax(a), ay(b) {}
	void PostaviXY(float x, float y) { ax = x; ay = y; }
	float DajX() { return ax; }
	float DajY() { return ay; }
	float MnoziSkalarnoSa(Vektor &vekt);
};

/* primjer javnog nasljeivanja

class Kompleksni : public Vektor {
public:
	Kompleksni(float a = 0, float b = 0) : Vektor(a, b) {}
	void MnoziSa(Kompleksni &broj);
};

*/

// privatno nasljeivanje

class Kompleksni : private Vektor {
public:
	Kompleksni(float a = 0, float b = 0) : Vektor(a, b) {}
	float Realni() { return DajX(); }
	float Imaginarni() { return DajY(); }
	void MnoziSa(Kompleksni &broj);
};


int main() {

	Kompleksni z1(1, 2), z2(3, 4);
	z1.MnoziSkalarnoSa(z2);		// pogreka u sluaju privatnog nasljeivanja
	return 0;
}
