//  vektor2.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 9.4.6. Iskljuivanje lanova

class Vektor {
private:
	float ax, ay;
public:
	Vektor(float a = 0, float b = 0) : ax(a), ay(b) {}
	void PostaviXY(float x, float y) { ax = x; ay = y; }
	float DajX() { return ax; }
	float DajY() { return ay; }
	float MnoziSkalarnoSa(Vektor &vekt);
};

class Kompleksni : public Vektor {
public:
	Kompleksni(float a = 0, float b = 0) : Vektor(a, b) {}
	void MnoziSa(Kompleksni &broj);
	Vektor::DajX;	  // iskljuuje DajX iz mehanizma
					  // privatnog nasljeivanja
	Vektor::DajY; 	  // iskljuuje DajY iz mehanizma
					  // privatnog nasljeivanja
};
