//  bubblesort.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 10.2.7. Primjer predloka funkcije za bubble sort


#include <iostream>
using namespace std;


template <class Elem>
void pisi_niz(Elem *niz, int brElem) {
	cout << "{ ";
	for (int i = 0; i < brElem; i++) {
		cout << niz[i];
		//zarez se ne tampa nakon zadnjeg elementa:
		if (i < brElem - 1) cout << ", ";
	}
	cout << "}" << endl;
}


template <class Elem>
void zamijeni(Elem& a, Elem& b) {
	Elem priv = a;
	a = b;
	b = priv;
}


template <class Elem>
void bubble_sort(Elem *niz, int brElem) {
	bool ok;
	for (int i = brElem - 1; i > 0; i--) {
		ok = true;
		for (int j = 0; j < i; j++)
			if (niz[j + 1] < niz[j]) {
				zamijeni(niz[j], niz[j + 1]);
				ok = false;
			}
		if (ok) break;
	}
}

int main() {
	int niz1[] = {4, 5, 2, 7, 1, 0, 9};
	double niz2[] = {2.6, 7.9, 1.4, 8.9, 9.9, 3.3};
	bubble_sort(niz1, 7);
	cout << "Niz cijelih brojeva:" << endl;
	pisi_niz(niz1, 7);
	bubble_sort(niz2, 6);
	cout << "Niz realnih brojeva:" << endl;
	pisi_niz(niz2, 6);

	char z;
	cin >> z;
	return 0;
}
