//  slice.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 10.6.2: Predloak razreda valarray

#include <iostream>
#include <valarray>
using namespace std;

template<class Element>
void Ispisi(const valarray<Element> &v, int stupaca) {
	for (int i = 0; i < v.size() / stupaca; i++) {
		for (int j = 0; j < stupaca; j++) 
			cout << v[i*stupaca+j] << '\t';
		cout << endl;
	}
}

int main() {
	valarray<double> v(12);
	int i;
	for (i = 0; i < 12; i++)
		v[i] = i + 1;

	Ispisi(v, 3);

	v[slice(2, 4, 3)] = valarray<double>(v[slice(0, 4, 3)]) * valarray<double>(v[slice(1, 4, 3)]);

	// ispiimo cijeli vektor
	Ispisi(v, 3);

	// ispiimo samo zadnji stupac
	Ispisi(valarray<double>(v[slice(2, 4, 3)]), 1);

	// pomnoimo drugi stupac s 2 i ispiimo ga
	v[slice(1, 4, 3)] = valarray<double>(v[slice(2, 4, 3)]) * 2.;
	Ispisi(valarray<double>(v[slice(1, 4, 3)]), 1);

	char z;
	cin >> z;
	return 0;
}