//  pokznak.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 12.4: Detaljnije o kljunoj rijei catch

#include <iostream>
using namespace std;


class PokZnak {
private:
	char *pokZn;
public:
	PokZnak(int duljina) : pokZn(new char[duljina]) {}
	PokZnak(char *pz) : pokZn(pz) {}
	~PokZnak() { cout << "Unistavam pokZn" << endl; delete [] pokZn; }
	operator char *() { return pokZn; }
};


void Problematicna() {
	cout << "Problematicna: bacam iznimku." << endl;
	throw 10;
}

void Func1() {
	PokZnak mem = new char[100];
	try {
		Problematicna();
	}
	catch (...) {
		cout << "Func1: hvatam i prosljeujem iznimku." << endl;
		throw;			// prosljeivanje iznimke
	}
}

void Func2() {
	int *pok = new int[50];
	try {
		Func1();
	}
	catch (int) {
		cout << "Func2: hvatam int iznimku." << endl;
		delete [] pok;
		cout << "Func2: prosljeujem iznimku." << endl;
		throw;
	}
	delete [] pok;
}

int main() {

	try {
		Func2();
	}
	catch(...) {
		cout << "Main: imam iznimku!" << endl;
	}

	char z;
	cin >> z;
	return 0;
}