//  dynamic_cast.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 13.3: Sigurna pretvorba

#include <iostream>
using namespace std;

class Linija {
// ...
public:
	virtual void Crtaj() { cout << "Crtam Liniju" << endl; }
	// ...
};

class LinijaSaStrelicama : public Linija {
// ...
public:
	virtual void Crtaj() { cout << "Crtam Liniju sa strelicama" << endl; }
	int tipStrelice;
	// ...
};


int main() {

	Linija *pokLinija = new LinijaSaStrelicama;
	LinijaSaStrelicama *lss = dynamic_cast<LinijaSaStrelicama *>(pokLinija);
	if (lss) {
		// ...
	}

	delete pokLinija;

	Linija &ln = *new Linija;
	try {
		dynamic_cast<LinijaSaStrelicama &>(ln).tipStrelice = 10;
	}
	catch (bad_cast) {
		cerr << "Loa pretvorba." << endl;
	}
	delete &ln;

	char z;
	cin >> z;
	return 0;
}



