//  linija.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 13.1: Statiki i dinamiki tipovi

#include <iostream>
using namespace std;

class Linija {
// ...
public:
	virtual void Crtaj() { cout << "Crtam Liniju" << endl; }
	// ...
};

class LinijaSaStrelicama : public Linija {
// ...
public:
	virtual void Crtaj() { cout << "Crtam Liniju sa strelicama" << endl; }
	// ...
};


int main() {
	Linija *ln = new Linija;
	ln->Crtaj();		// pozvat e Linija::Crtaj i iscrtat e
						// obinu liniju na ekranu
	delete ln;
	ln = new LinijaSaStrelicama;
	ln->Crtaj();		// pozvat e LinijaSaStrelicama::Crtaj
						// i iscrtat e liniju sa strelicama
	delete ln;

	char z;
	cin >> z;
	return 0;
}
