//  linijaTip.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 13.1: Statiki i dinamiki tipovi

#include <iostream>
using namespace std;

const int CLS_LINIJA					= 1;
const int CLS_LINIJASASTRELICAMA		= 2;

class Linija {
// ...
public:
	virtual void Crtaj() { cout << "Crtam Liniju" << endl; }
	virtual int Tip() { return CLS_LINIJA; }
	virtual ~Linija() { cout << "Unitavam Liniju" << endl; }
	// ...
};

class LinijaSaStrelicama : public Linija {
// ...
public:
	virtual void Crtaj() { cout << "Crtam Liniju sa strelicama" << endl; }
	virtual int Tip() { return CLS_LINIJASASTRELICAMA; }
	virtual ~LinijaSaStrelicama() { cout << "Unitavam Liniju sa strelicama" << endl; }
	// ...
};


int main() {
	Linija *niz[8];
	int duljNiza = 0;
	// inicijalizacija elemenata niza
	niz[duljNiza++] = new Linija;
	niz[duljNiza++] = new LinijaSaStrelicama;
	niz[duljNiza++] = new Linija;
	niz[duljNiza++] = new LinijaSaStrelicama;
	niz[duljNiza++] = new Linija;
	niz[duljNiza++] = new LinijaSaStrelicama;
	niz[duljNiza++] = new Linija;
	niz[duljNiza++] = new LinijaSaStrelicama;

	// crtanje samo linija
	int i;
	for (i = 0; i < duljNiza; i++)
		if (niz[i]->Tip() == CLS_LINIJA)
			niz[i]->Crtaj();


	for (i = 0; i < duljNiza; i++)
		delete *(niz+i);

	char z;
	cin >> z;
	return 0;
}
