//  class.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 11.3.1 Deklaracija using

#include <iostream>
using namespace std;

class A {
private:
	int i;
protected:
	int j;
public:
	A(int a, int b) : i(a), j(b) {}
};

class B {
public:
	int k;
};

/*
class C : public A {
public:
	using B::k;		// pogreka: B nije osnovna klasa od A
	using A::i;		// pogreka: i nije dostupan u klasi C
	using A::j;		// OK: j e u klasi C imati javni
					// pristup
};
*/

class C : public A {
public:
	C() : A(5, 10) {}
	using A::j;
};

int main() {
	C obj;
	cout << obj.j << endl;		// ispisuje 10

	char z;
	cin >> z;
	return 0;
}
