#ifndef KRUZNICA_H
#define KRUZNICA_H

#include "tocka.h"
#include "pravac.h"

class Kruznica {
public:
	Kruznica(Tocka s, double r) : srediste(s), polumjer(r) {}
	double r() const { return polumjer; }
	double x0() const { return srediste.x(); }
	double y0() const { return srediste.y(); }
private:
	Tocka srediste;
	double polumjer;
	int nista;
};

#endif
