//  bubblesort1.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Iteratori

#include <iostream>
#include <vector>
#include <string>
using namespace std;


template <class Elem>
void zamijeni(Elem& a, Elem& b) {
	Elem priv = a;
	a = b;
	b = priv;
}


template <class Elem>
void mjehSort(vector<Elem>& niz) {
	for (int i = niz.size() - 1; i > 0; i--) {
		bool zamjena = false;
		for (int j = 0; j < i; j++)
			if (niz[j + 1] < niz[j]) {
				zamijeni(niz[j], niz[j + 1]);
				zamjena = true;
			}
		if (zamjena == false)
			break;
	}
}


int main() {

	vector<int> brojke;
	brojke.push_back(3);
	brojke.push_back(14);
	brojke.push_back(7);
	brojke.push_back(19);

	mjehSort(brojke);
	
	int i;
	for (i = 0; i < brojke.size(); i++)
		cout << brojke[i] << endl;

	vector<string> slova;
	slova.push_back(string("Mihovil"));
	slova.push_back(string("Neven"));
	slova.push_back(string("Grigor"));
	slova.push_back(string("Dora"));
	slova.push_back(string("Matej"));

	mjehSort(slova);
	
	for (i = 0; i < slova.size(); i++)
		cout << slova[i] << endl;

	char z;
	cin >> z;
	return 0;
}
