//  bubblesort2.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Iteratori

#include <iostream>
#include <vector>
#include <string>
using namespace std;


template <class Elem>
void zamijeni(Elem& a, Elem& b) {
	Elem priv = a;
	a = b;
	b = priv;
}


template <class Elem>
void mjehSort(Elem *prvi, Elem *zadnji) {
	for (Elem *pok1 = zadnji - 1; pok1 > prvi; pok1--) {
		bool zamjena = false;
		for (Elem *pok2 = prvi; pok2 < pok1; pok2++)
			if (*(pok2 + 1) < *pok2) {
				zamijeni(*pok2, *(pok2+1));
				zamjena = true;
			}
		if (zamjena == false)
			break;
	}
}


int main() {

	vector<int> brojke;
	brojke.push_back(3);
	brojke.push_back(14);
	brojke.push_back(7);
	brojke.push_back(19);

//	mjehSort(&brojke[0], &brojke[4]);
//	mjehSort(brojke.begin(), brojke.end());
	mjehSort(&brojke.front(), &brojke.back()+1);
	
	int i;
	for (i = 0; i < brojke.size(); i++)
		cout << brojke[i] << endl;

	vector<string> slova;
	slova.push_back(string("Mihovil"));
	slova.push_back(string("Neven"));
	slova.push_back(string("Grigor"));
	slova.push_back(string("Dora"));
	slova.push_back(string("Matej"));

	mjehSort(&slova[0], &slova[5]);
	
	for (i = 0; i < slova.size(); i++)
		cout << slova[i] << endl;

	int brojevi[] = { 101, 345, 237, 452, 134};

	mjehSort(&brojevi[0], &brojevi[5]);
	
	for (i = 0; i < 5; i++)
		cout << brojevi[i] << endl;

	char z;
	cin >> z;
	return 0;
}
