//  iterator_napredni.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Iteratori - Iteratori prema naprijed


#include <iostream>
#include <fstream>
#include <iterator>
using namespace std;

template<class NapredniIterator, class T>
NapredniIterator pronadji(NapredniIterator prvi,
						 NapredniIterator zadnji,
						 T& vrijednost) {
	while (prvi != zadnji) {
		if (*prvi == vrijednost)
			return prvi;
		prvi++;
	}
	return zadnji;
}


int main() {
	ifstream ulaz("podaci.txt");

	istream_iterator<int> elem = pronadji(istream_iterator<int>(ulaz), istream_iterator<int>(), 15);

	if (elem != istream_iterator<int>())
		cout << *elem << endl;
	else
		cout << "element nije nadjen!" << endl;

	char z;
	cin >> z;
	return 0;
}