//  map1.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Asocijativni spremnici


#include <iostream>
#include <map>
#include <string>
using namespace std;


int main() {

	typedef map<string, float> StringFloatMapa;

	StringFloatMapa cjenik;

	cjenik.insert(make_pair(string("mlijeko"), 4.05));
	cjenik.insert(make_pair(string("kruh"), 5.50));
	cjenik.insert(make_pair(string("kefir"), 6.25));
	cjenik.insert(make_pair(string("mineralna voda"), 3.15));

	cjenik.insert(pair<string, float> ("pivo", 4.25));

	cjenik.insert(StringFloatMapa::value_type("greentseig", 2.25));

	StringFloatMapa::iterator pozicija;

	cout << "Cjenik:" << endl;

	for (pozicija = cjenik.begin(); pozicija != cjenik.end(); pozicija++) 
		cout << pozicija->first << "\t" << pozicija->second << endl;


	cout << endl;

	pozicija = cjenik.find("mlijeko");
	pozicija->second = 4.10;

	cout << "Cijena mlijeka je: " << cjenik["mlijeko"] << endl;

	cjenik["kravlje mlijeko"] = cjenik["mlijeko"];

	char z;
	cin >> z;
	return 0;
}

