//  nadji3.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Iteratori

#include <iostream>
#include <vector>
using namespace std;


template <class tipElementa>
const tipElementa* pronadji(const tipElementa *prvi,
					  const tipElementa *zadnji,
					  const tipElementa &vrijednost) {
	while (prvi < zadnji) {
		if (*prvi == vrijednost)
			return prvi;
		prvi++;
	}
	return 0;
}


int main() {

	vector<int> brojke;
	brojke.push_back(3);
	brojke.push_back(14);
	brojke.push_back(7);
	brojke.push_back(19);

	const int trazeni = 7;

	if ((pronadji(&brojke[0], &brojke[brojke.size()], trazeni)) != 0)
		cout << "Naao sam traeni broj " << trazeni << endl;
	else
		cout << "Nisam naao traeni broj " << trazeni << endl;


	char z;
	cin >> z;
	return 0;
}
