//  pair.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Asocijativni spremnici


#include <iostream>
#include <cmath>
using namespace std;

template <class Tip>
pair<Tip, Tip> PravokutneUPolarne(Tip x, Tip y) {
	pair<Tip, Tip> rezultat;
	rezultat.first = sqrt(x * x + y * y);
	rezultat.second = atan2(x, y);
	return rezultat;
}


int main() {

	pair<double, double> p1 = PravokutneUPolarne(1. , 1.);

	cout << "modul = " << p1.first << endl;
	cout << "kut = " << p1.second << endl;

	char z;
	cin >> z;
	return 0;
}

