//  priority_queue.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Prioritetni red


#include <iostream>
#include <queue>
using namespace std;


int main() {

	priority_queue<int> brojevi;

	// umetnimo tri elementa
	brojevi.push(2);
	brojevi.push(4);
	brojevi.push(3);

	// ispiimo element s vrha i maknimo ga:
	cout << brojevi.top() << endl;
	brojevi.pop();

	// dodajmo jo jedan element:
	brojevi.push(6);

	// ispiimo sada sve elemente:
	while (!brojevi.empty()) {
		cout << brojevi.top() << endl;
		brojevi.pop();
	}

	char z;
	cin >> z;
	return 0;
}

