//  set4.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Asocijativni spremnici


#include <iostream>
#include <set>
using namespace std;


int main() {

	set<int> cijeliBrojevi;
	cijeliBrojevi.insert(1);
	cijeliBrojevi.insert(3);
	cijeliBrojevi.insert(4);
	cijeliBrojevi.insert(5);

	set<int>::iterator prvi = cijeliBrojevi.begin();
	set<int>::iterator zadnji = cijeliBrojevi.end();

	cout << "Skup cijelih brojeva od najmanjeg:" << endl;

	while (prvi != zadnji) 
		cout << *prvi++ << endl;

	cout << "lower_bound(2): " << *cijeliBrojevi.lower_bound(2) << endl;
	cout << "upper_bound(2): " << *cijeliBrojevi.upper_bound(2) << endl;
	cout << "equal_range(2): " << *cijeliBrojevi.equal_range(2).first << " " 
							   << *cijeliBrojevi.equal_range(2).second << endl;

	
	cout << "lower_bound(4): " << *cijeliBrojevi.lower_bound(4) << endl;
	cout << "upper_bound(4): " << *cijeliBrojevi.upper_bound(4) << endl;
	cout << "equal_range(4): " << *cijeliBrojevi.equal_range(4).first << " " 
							   << *cijeliBrojevi.equal_range(4).second << endl;

	char z;
	cin >> z;
	return 0;
}

