//  sort2.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Algoritmi i funkcijski objekti


#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iterator>
#include <ctime>
#include <locale>
using namespace std;


bool CroManji(const string &prvi, const string &drugi) {
	if (strcoll(prvi.c_str(), drugi.c_str()) < 0)
		return true;
	return false;
}

int main() {

	vector<string> igraci;
	igraci.push_back(string("Dora"));
	igraci.push_back(string("ivan"));
	igraci.push_back(string("lucija"));
	igraci.push_back(string("luka"));
	igraci.push_back(string("Marija"));
	igraci.push_back(string("matej"));
	igraci.push_back(string("imun"));
	igraci.push_back(string("tomo"));


	srand((unsigned)time(NULL));

	vector<string>::iterator prvi = igraci.begin();

	for (int i = 0; i < 10; i++) {
		vector<string>::iterator vadi = prvi + rand() % igraci.size();
		vector<string>::iterator umetni = prvi + rand() % igraci.size();
		if (vadi != umetni)
			iter_swap(vadi, umetni);
	}

	vector<string>::iterator zadnji = igraci.end();

	cout << "Redoslijed nakon mijeanja:" << endl;

	while (prvi != zadnji)
		cout << *prvi++ << endl;

	locale::locale("");

	sort(igraci.begin(), igraci.end(), CroManji);

	prvi = igraci.begin();

	cout << "Redoslijed nakon sortiranja:" << endl;

	while (prvi != zadnji)
		cout << *prvi++ << endl;

	char z;
	cin >> z;
	return 0;
}

