//  matematika.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Priloga B: matematike funkcije

#include <iostream>
#include <cmath>
using namespace std;

int main() {

	const double PI = 3.1415926535;

	cout << fabs(-123.4) << endl;

	cout << acos(0.) << endl;

	cout << asin(-1.) << endl;

	cout << atan(-1.) << endl;

	cout << atan2(-1., 0.) << endl;

	cout << cos(PI) << endl;

	cout << cosh(0.) << endl;

	div_t r = div(10, 3);
	cout << "kvocijent: " << r.quot << endl
		 << "ostatak:   " << r.rem << endl;

	cout << exp(2.) << endl;

	double broj = 4.;
	int eksponent;
	double mantisa = frexp(broj, &eksponent);
	cout << broj << " = " << mantisa << " * 2 na " << eksponent << endl;

	cout << ldexp(2., 3) << endl;

	cout << log(10.) << endl;

	broj = 94.3;
	double cijeli;
	double decimalni = modf(broj, &cijeli);
	cout << broj << " = " << decimalni << " + " << cijeli << endl;

	cout << pow(10., 3.) << endl;

	const double PI_2 = 1.5707963268;
	cout << sin(PI_2) << endl;

	cout << sinh(1.) << endl;

	cout << sqrt(2.) << endl;

	cout << tan(0.7853981634) << endl;

	cout << tanh(1.) << endl;

	char z;
	cin >> z;
	return 0;
}
