//  accumulate.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Priloga C: Generiki algoritmi

#include <iostream>
#include <vector>
#include <list>
#include <numeric>
#include <functional>
using namespace std;


template<class T>
class umnozak : public binary_function<T, T, T> {
public:
    T operator()(const T& x, const T& y) const { return x * y; }
};


int main() {
	int ia[] = {1, 3, 5, 7, 14, 20};
	vector<int> v(ia, ia+6);
	list<int> l(ia, ia+6);

	// ispisuje 50
	cout << accumulate(v.begin(), v.end(), 0) << endl;

	double rez = accumulate(v.begin(), v.end(), 1., umnozak<float>());
	
	// ispisuje 29400
	cout << rez << endl;

	char z;
	cin >> z;
	return 0;
}