//  binary_search.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Priloga C: Generiki algoritmi

#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <functional>
using namespace std;



int main() {
	int ia[] = {1, 3, 5, 7, 14, 20};
	vector<int> v(ia, ia+6);

	// ispisuje 1
	cout << "Naao 5 u nizu: " << binary_search(v.begin(), v.end(), 5) << endl;

	// ispisuje 0
	cout << "Naao 9 u nizu: " << binary_search(v.begin(), v.end(), 9) << endl;


	float fa[] = { 45., 23., 17., 11., 9., 5. };
	vector<float> vf(fa, fa+6);

	// ispisuje 1
	cout << "Naao 17. u nizu: " << binary_search(vf.begin(), vf.end(), 17, greater<float>()) << endl;

	// ispisuje 0
	cout << "Naao 17. u nizu: " << binary_search(vf.begin(), vf.end(), 17, less<float>()) << endl;

	char z;
	cin >> z;
	return 0;
}