//  copy.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Priloga C: Generiki algoritmi

#include <iostream>
#include <vector>
#include <list>
#include <numeric>
#include <algorithm>
#include <functional>
using namespace std;


template<class T>
class umnozak : public binary_function<T, T, T> {
public:
    T operator()(const T& x, const T& y) const { return x * y; }
};


class neparan  {
public:
    bool operator()(int x)  { return x % 2 ? true : false; }
};


void ispisiElement(int elem) { cout << elem << endl; }


class GeneratorBrojeva {
public:
	int operator()() { return rand(); }
};


int main() {
	int ia[] = {1, 3, 5, 7, 14, 20};
	vector<int> v(ia, ia+6);
	list<int> l(ia, ia+6);

	// ispisuje: 1, 3, 5, 7, 14, 20
	ostream_iterator<int> naKonzolu(cout, " ");
	copy(v.begin(), v.end(), naKonzolu);

	cout << endl;

/*
	int nputa = count(v.begin(), v.end(), 7);
	cout << "Nasao " << nputa << endl;

	cout << count_if(v.begin(), v.end(), neparan()) << endl;

	if (find(v.begin(), v.end(), 12) == v.end())
		cout << "Nisam naao broj 12" << endl;;

	for_each(v.begin(), v.end(), ispisiElement); 

	vector<int> v2(10);

	generate(v2.begin(), v2.end(), GeneratorBrojeva());
	for_each(v2.begin(), v2.end(), ispisiElement); 
*/
	
	char z;
	cin >> z;
	return 0;
}
