#include <iostream>
#include <string>
#include <windows.h>
using namespace std;


class domaciNiz : public string {
public:
	domaciNiz(char *znNiz) : string(znNiz) {;}
	domaciNiz() : string() {;}
	domaciNiz(string str) : string(str) {;}
	string PisiPoVuku() const;
	void CitajPoVuku(string str);
};

string domaciNiz::PisiPoVuku() const {
	char *szDOStext = new char[length() + 1];
	CharToOem(c_str(), szDOStext);
	const string strDOStext(szDOStext);
	delete [] szDOStext;
	return strDOStext;
}

void domaciNiz::CitajPoVuku(string str) {
	char *szWinText = new char[str.length() + 1];
	OemToChar(str.c_str(), szWinText);
	assign(szWinText);
	delete [] szWinText;
	return;
}

ostream& operator<<(ostream &os, const domaciNiz &nN) {
	return os << nN.PisiPoVuku();
}

istream& operator>>(istream &is, domaciNiz &nN) {
	if (!is)
		return is;
	string str;
	is >> str;
	nN.CitajPoVuku(str);
	return is;
}


int main() {
	cout << domaciNiz("Upii svoje ime papino:");
	domaciNiz ime;
	cin >> ime;

	cout << domaciNiz(ime) << endl;

	domaciNiz prezime(" u boj");
	string tuti = ime + prezime;

	cout << tuti << endl;

    domaciNiz tuti2 = ime + prezime;
    cout << tuti2 << endl;

	char z;
	cin >> z;

	return 0;
}