// pogodilica.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 3.7 Blok do-while
// Petlja se ponavlja petlju dok ne pogodi sluajni broj izmeu 1 i 100

#include <iostream>
#include <cstdlib>
#include <ctime>
using namespace std;

int main() {
	int raspon = 100;
	srand(time(NULL));	// inicijalizira generator slu. br.
	// generira sluajni broj izmeu 1 i raspon
	int trazeniBroj = static_cast<float>(rand()) / RAND_MAX 
					  * (raspon - 1) + 1;
	cout << "Treba pogoditi broj izmeu 1 i " 
		 << raspon << endl; 
	int mojBroj;
	int brojPokusa = 0;

	do {
		cout << ++brojPokusa << ". pokuaj: ";
		cin >> mojBroj;
		if (mojBroj > trazeniBroj)
			cout << "MANJE!" << endl;
		else if (mojBroj < trazeniBroj)
			cout << "VIE!" << endl;
	} while(mojBroj != trazeniBroj);

	cout << "BINGO!!!" << endl;

	char z;
	cin >> z;
	return 0;
}
