// pokaritmet.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 4.2.4 Aritmetike operacije s pokazivaima
// Pronalaenje zapisa s najveom vrijednosu prvog odnosno drugog lana
// te pohranjivanje pokazivaa na njega

#include <iostream>
#include <fstream>
using namespace std;

int main() {
	ifstream ulTok("podaci.dat");
	if (!ulTok) {
		cerr << "Ne mogu otvoriti datoteku s ulaznim podacima!" << endl;
		return 1;
	}
	const nmax = 20;
	int ljudi[nmax][2] = {0, 0};
	int *najvisi = ljudi[0];
	int *najtezi = ljudi[0];
	int i = 0;
	while (ulTok >> ljudi[i][0] >> ljudi[i][1]) {
		if (ljudi[i][0] > *najvisi)
			najvisi = ljudi[i];
		if (ljudi[i][1] > *(najtezi+1))
			najtezi = ljudi[i];
		i++;
	}
	cout << "Najvia osoba ima " << *najvisi << " cm i " << *(najvisi+1) << " kg."<< endl;
	cout << "Ona se skriva pod rednim brojem " << ((najvisi - ljudi[0]) / 2 + 1) << endl;
	cout << "Najtea osoba ima " << *(najtezi+1) << " kg i " << *najtezi << " cm."<< endl;
	cout << "Ona se skriva pod rednim brojem " << ((najtezi - ljudi[0]) / 2 + 1) << endl;

	char z;
	cin >> z;
	return 0;
}

