// pokipolje.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 4.2.3 Tajna veza izmeu pokazivaa i polja
// Pronalaenje lana polja s najveom vrijednosu 
// te pohranjivanje pokazivaa na njega

#include <iostream>
#include <fstream>
using namespace std;

int main() {
	ifstream ulTok("podaci.dat");
	if (!ulTok) {
		cerr << "Ne mogu otvoriti datoteku s ulaznim podacima!" << endl;
		return 1;
	}
	const nmax = 20;
	int visine[nmax] = {0};
	int *najvisi = visine;
	int i = 0;
	while (ulTok >> visine[i]) {
		if (visine[i] > *najvisi)
			*najvisi = visine[i];
		i++;
	}
	cout << "Najvisa osoba ima " << *najvisi << " cm." << endl;

	char z;
	cin >> z;
	return 0;
}

