// mocnica.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 5.8 Preoptereenje funkcija
// Primjer preoptereenja funkcija razliitim algoritmima

#include <iostream>
#include <cmath>
using namespace std;

double mocnica(double x, double y) {
	if (x <= 0.) {
		cerr << "Nemoan sam to izraunati!" << endl;
		return 0.;
	}
	return exp(y * log(x));
}

double mocnica(double x, int y) {
	int brojac = y > 0 ? y : - y;
	double rezultat = 1.;
	while (brojac-- > 0)
		rezultat *= x;
	return y > 0 ? rezultat : 1. / rezultat;
}

int main() {
	cout << mocnica (2, 3) << endl;
	cout << mocnica (2, 3.5) << endl;

	char z;
	cin >> z;
	return 0;
}