// brojeni.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 6.8.1 Statiki podtakovni lanovi
// Klasa Brojeni s statikim podatkovnim lanom

#include <iostream>
using namespace std;

class Brojeni {
public:
	static int Brojac;		// statiki podatkovni lan
	int MojBroj;

	Brojeni();
	~Brojeni();
	void IspisiBrojace();
};

Brojeni::Brojeni() : MojBroj(Brojac++) {
	cout << "Stvoren element br.: " << MojBroj << endl;
}

Brojeni::~Brojeni() {
	cout << "Unisten element br.: " << MojBroj << endl;
}

//int Brojeni::Brojac = 0;

void Brojeni::IspisiBrojace() {
	cout << "Brojac: " << Brojac << endl;
	// ovo je pristup iznutra
	cout << "Moj broj: " << MojBroj << endl;
}

int main() {
	{
		Brojeni bb;
		Brojeni::Brojac = 5;	// pristup izvana operatorom ::
		bb.Brojac = 5;			// isto kao i prethodna naredba
		bb.IspisiBrojace();

		char z;
		cin >> z;
	}

	char z;
	cin >> z;
	return 0;
}
