// znakobrojac.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 6.4.1 Konstruktor
// Primjer konstruktora

#include <cassert>
//#include <cstdlib>

class Tablica {
private:
	int *Elementi;
	int BrojElem, Duljina;
public:
	Tablica();
	Tablica(int BrElem);
	void PovecajNa(int NovaDulj);
	void DodajElem(int Elt);
	void BrisiElem(int Poz);
};

Tablica::Tablica() :
			Elementi(new int[10]),
			BrojElem(0), Duljina(10) {
	assert(Elementi != 0);
}

Tablica::Tablica(int BrElem) :
			Elementi(new int[BrElem]),
			BrojElem(0), Duljina(BrElem) {
	assert(Elementi != 0);
}

void Tablica::PovecajNa(int NovaDulj) {
	int *Nova=new int[NovaDulj];
	assert(Nova != 0);
	for (int i = 0; i < BrojElem; i++)
		Nova[i] = Elementi[i];
	Duljina = NovaDulj;
	delete [] Elementi;
	Elementi = Nova;
}

void Tablica::DodajElem(int Elt) {
	if (Duljina == BrojElem) 
		PovecajNa(Duljina + 10);
	Elementi[BrojElem++] = Elt;
}

void Tablica::BrisiElem(int poz) {
	assert(poz < BrojElem);
	for (int i = poz; i < BrojElem - 1; i++)
		Elementi[i] = Elementi[i+1];
	BrojElem--;
}
