// razlucivanjekonverzije1.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 8.1.3. Operatori konverzije
// ilustracija problema razluivanja konverzije

#include <iostream>
#include <cstring>
using namespace std;

class ZnakovniNiz {
private:
	char *pokNiz;

public:
	ZnakovniNiz(char *niz = "");
	operator char*() { return pokNiz; };
	operator int() { return strlen(pokNiz); }
};


ZnakovniNiz::ZnakovniNiz(char *niz) : pokNiz(new char[strlen(niz) + 1]) {
	strcpy(pokNiz, niz);
}


void Ispisi(char *pokZnak) {
	cout << "Ispisujem niz: " << pokZnak << endl;
}


void Ispisi(int broj) {
	cout << "Ispisujem broj: " << broj << endl;
}


void PisiLong(long broj) {
	cout << "Long broj: " << broj << endl;
}


int main() {
	ZnakovniNiz a = "U to e me pretvoriti?";
//	Ispisi(a);		// pogreka: koja konverzija?
	Ispisi(static_cast<char *>(a));

	PisiLong(a);	// poziva se konverzija u int, a int
					// se zatim standardnom konverzijom
					// pretvara u long

	return 0;
}
