// znakniz.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 8.3.1. Operator =

#include <iostream>
#include <cstring>
using namespace std;


class ZnakovniNiz {
	char *pokNiz;
public:
	ZnakovniNiz(char *znNiz = "") : pokNiz(new char[strlen(znNiz) + 1]) { strcpy(pokNiz, znNiz); }
	ZnakovniNiz& operator=(const ZnakovniNiz &desno);
};

ZnakovniNiz& ZnakovniNiz::operator=(const ZnakovniNiz
									&desno) {
	if (&desno != this) {
		delete [] pokNiz;
		pokNiz = new char[strlen(desno.pokNiz) + 1];
		strcpy(pokNiz, desno.pokNiz);
	}
	return *this;
}


int main() {
	ZnakovniNiz a, b("Haleluja");
	a = b;

	cout << b << endl;

	cout << a << endl;

	return 0;
}