// znakniz.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 8.3.3. Operator ()

#include <iostream>
#include <cstring>
using namespace std;

class ZnakovniNiz {
	char *pokNiz;
public:
	ZnakovniNiz(char *niz) : pokNiz(new char[strlen(niz) + 1]) { strcpy(pokNiz, niz); }
	operator char*() { return pokNiz; }
	ZnakovniNiz operator()(int start, int duljina);
};

ZnakovniNiz ZnakovniNiz::operator()(int start,
								    int duljina) {
	char pomocni[200], *pok1 = pomocni;
	char *pok2 = pokNiz + start;
	while (duljina-- && *pok2) *(pok1++) = *(pok2++);
	*pok1 = 0;
	return ZnakovniNiz(pomocni);
}


int main() {
	ZnakovniNiz a = "Kramer protiv Kramera";
	cout << static_cast<const char *>(a(2, 17)) << endl;
	return 0;
}
