// znakniz.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 8.1 Konverzija konstruktorom
// ilustracija stvaranja i unitenja objekta u konstruktoru/destruktoru

#include <iostream>
#include <cstring>
using namespace std;

class ZnakovniNiz {

private:

	char *pokNiz;

public:

	ZnakovniNiz(char *niz = "");
	ZnakovniNiz(const ZnakovniNiz &ref);
	~ZnakovniNiz();
	char *DajPokazivac() { return pokNiz; }
};


ZnakovniNiz::ZnakovniNiz(char *niz) : pokNiz(new char[strlen(niz) + 1]) {
	strcpy(pokNiz,niz);
	cout << "Stvoren niz: " << niz << endl;
}


ZnakovniNiz::ZnakovniNiz(const ZnakovniNiz &ref) : pokNiz(new char[strlen(ref.pokNiz) + 1]) {
	strcpy(pokNiz, ref.pokNiz);
}


ZnakovniNiz::~ZnakovniNiz() {
	cout << "Uniten niz: " << pokNiz << endl;
	delete [] pokNiz;
};



void Funkcija(ZnakovniNiz niz) {
	cout << "Pozvana funkcija s parametrom: ";
	cout << niz.DajPokazivac() << endl;
}



int main() {
	ZnakovniNiz a = "Niz a";
	Funkcija("parametar");

//	char z;
//	cin >> z;
	return 0;
}
