//  AB.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 9.11. Virtualni funkcijski lanovi


#include <iostream>
using namespace std;

class A {
public:
	void func() { cout << "A::func()" << endl; }
};

class B : public A {
public:
	virtual void func() { cout << "B::func()" << endl; }
};

class C : public B {
public:
	virtual void func() { cout << "C::func()" << endl; }
};

int main() {
	C objc;
	A *pokA = &objc;
	B *pokB = &objc;
	pokA->func();		// ispisuje A::func()
	pokB->func();		// ispisuje C::func()

	char z;
	cin >> z;
	return 0;
}
