//  grafobjekt.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 9.11.1. Virtualni funkcijski lanovi

enum TBoja {BIJELA, CRVENA, PLAVA, ZELENA, CRNA};

class GrafObjekt {
private:
	TBoja Boja;
public:
	void PostaviBoju(TBoja nova) { Boja = nova; }
	TBoja CitajBoju() { return Boja; }
	virtual void Crtaj() {}
	virtual void Translatiraj(int, int) {}
	virtual void Rotiraj(int, int, int) {}
};

class Linija : public GrafObjekt {
private:
	int x1, y1, x2, y2;
public:
	Linija(int lx1, int ly1, int lx2, int ly2) :
		x1(lx1), y1(ly1), x2(lx2), y2(ly2) {}
	virtual void Crtaj();
	virtual void Translatiraj(int vx, int vy);
	virtual void Rotiraj(int cx, int cy, int kut);
};
