//  exponenc.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 10.4. Mjesto instantacije

#include <iostream>
using namespace std;

double faktorijel(double) { 
	cout << "double faktorijel()" << endl;
	return 10.; 
}


template <class T>
T OpciExp(T x, int brKoraka) {
	T rez = 0;
	for (int i = 0; i <= brKoraka; i++)
		rez += NaPotenciju(x, i) / faktorijel(i);
	return rez;
}

double NaPotenciju(double baza, int eksponent) { 
	cout << "double NaPotenciju()" << endl;
	return 10.; 
}

long NaPotenciju(int, int) { 
	cout << "long NaPotenciju()" << endl;
	return 10; 
}

/*long faktorijel(int) { 
	cout << "long faktorijel()" << endl;
	return 1; 
}*/

int main() {
	double e = OpciExp(1, 20);
	cout << e << endl;

	char z;
	cin >> z;
	return 0;
}
