//  gslice.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 10.6.2: Predloak razreda valarray

#include <iostream>
#include <valarray>
using namespace std;

int main() {
	const int redaka = 4;
	const int stupaca = 3;
	valarray<double> v(redaka * stupaca);
	int i;
	for (i = 0; i < redaka*stupaca; i++)
		v[i] = (i + redaka) / redaka + (i % redaka + 1) * 10;

	for (i = 0; i < v.size(); i++) 
		cout << v[i] << endl;

	size_t poljeDuljina[] = { 2, 3 };
	size_t poljePrirasta[] = { 4, 1 };

	valarray<size_t> duljine(poljeDuljina, 2);
	valarray<size_t> prirasti(poljePrirasta, 2);

	valarray<double> vSubmatrica = v[gslice(0, duljine, prirasti)];

	cout << "Submatrica:" << endl;
	for (i = 0; i < vSubmatrica.size(); i++) 
		cout << vSubmatrica[i] << endl;

	char z;
	cin >> z;
	return 0;
}