//  grafobjekt.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 10.2.6. Specijalizacija predloaka funkcija

#include <string>

// predloak za openite tipove
template <class Tip>
Tip manji(Tip a, Tip b) {
	return a < b ? a : b;
}

// specijalizacija za char sluaj
char *manji(char *a, char *b) {
	return strcmp(a, b) < 0 ? a : b;
}


template <class T1, class T2>
void f();				// originalni predloak

template <class T>
f<T, char>();			// djelomina specijalizacija
