//  valarray.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 10.6.2: Predloak razreda valarray

#include <iostream>
#include <valarray>
#include <cmath>
using namespace std;

int main() {
	valarray<int> v3;
	valarray<int> v1(2, 5);	// deset elemenata s vrijednou 2

	int i;
	cout << "v1: " << endl;
	for (i = 0; i < v1.size(); i++) 
		cout << v1[i] << endl;

	int brojevi[] = { 3, 5, 7, 9, 11 };
	valarray<int> v2(brojevi, sizeof(brojevi)/sizeof(brojevi[0]));

	cout << "v2: " << endl;
	for (i = 0; i < v2.size(); i++) 
		cout << v2[i] << endl;


	cout << "v3: " << endl;
	v3 = v1 * v2;
	for (i = 0; i < v3.size(); i++) 
		cout << v3[i] << endl;


	cout << "v4: " << endl;
	valarray<int> v4 = 2 * v2;
	for (i = 0; i < v4.size(); i++) 
		cout << v4[i] << endl;


	v4 += 5;
	cout << "v4 nakon dodavanja 5: " << endl;
	for (i = 0; i < v4.size(); i++) 
		cout << v4[i] << endl;

	int par [] = { 2, 4, 6, 8, 10 };
	valarray<int> vpar(par,sizeof(par)/sizeof(par[0]));
	valarray<int> osmice(8, 5);
	valarray<bool> vb = vpar == osmice;

	cout << "vb: " << endl;
	for (i = 0; i < vb.size(); i++) 
		cout << vb[i] << endl;


	valarray<double> vd(5);
	for (i = 0; i < 5; i++)
		vd[i] = par[i];

	valarray<double> vdexp = exp(vd);
		
	cout << "vdexp: " << endl;
	for (i = 0; i < vdexp.size(); i++) 
		cout << vdexp[i] << endl;

	char z;
	cin >> z;
	return 0;
}