//  auto_ptr.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 12.6: Iznimke u konstruktoru

#include <iostream>
#include <memory>
#include <string>
#include <new>
using namespace std;

class MojObjekt {
	string ime;
public:
	MojObjekt(const char *text) : ime(text) 
		{ cout << ime << "Ja sam iv! "; }
	~MojObjekt() { cout << ime << ": Umirem!" << endl; }
	void DajMiIme() { cout << ime << endl; }
};


void Ozivljavanje(const char *niz) {
	MojObjekt *mo1 = new MojObjekt(niz);
	mo1->DajMiIme();
}

void OzivljavanjeSEutanazijom(const char *niz) {
	auto_ptr<MojObjekt> mo2(new MojObjekt(niz));
	mo2->DajMiIme();
}

int main() {

	Ozivljavanje("Ante");
	OzivljavanjeSEutanazijom("Adolf");

	char z;
	cin >> z;
	return 0;
}
