//  konstruktor.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 12.6: Iznimke u konstruktoru

#include <iostream>
#include <string>
using namespace std;


class ZnakovniNiz {
private:
	string znaNiz;
public:
	class Iznimka { 
		string poruka;
	public:
		Iznimka(const char* tekst) : poruka(tekst) { ; }
		string DajPoruku() { return poruka; }
	};

	ZnakovniNiz(const char *niz = "");
	string DajVrijednost() { return znaNiz; }
};

ZnakovniNiz::ZnakovniNiz(const char *niz) {
	if (strlen(niz) > 80) throw Iznimka("Niz je predugaak.");
	znaNiz = niz;
}

int main() {
	
	try {
		ZnakovniNiz* zn = new ZnakovniNiz("Supercalifragilisticexpialidocious");
		cout << zn->DajVrijednost() << endl;
	}
	catch (ZnakovniNiz::Iznimka &izn) {
		cout << (izn.DajPoruku()) << endl;
	}

	char z;
	cin >> z;
	return 0;
}