//  problematicna.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 12.4: Detaljnije o kljunoj rijei catch

#include <iostream>
using namespace std;

void Problematicna() {
	cout << "Problematicna: bacam iznimku." << endl;
	throw 10;
}

void Func1() {
	char *mem = new char[100];
	try {
		Problematicna();
	}
	catch (...) {
		cout << "Func1: hvatam iznimku." << endl;
		delete [] mem;	// ienje zauzetih resursa
		cout << "Func1: prosljeujem iznimku." << endl;
		throw;			// prosljeivanje iznimke
	}
	delete [] mem;
}

void Func2() {
	int *pok = new int[50];
	try {
		Func1();
	}
	catch (int) {
		cout << "Func2: hvatam int iznimku." << endl;
		delete [] pok;
		cout << "Func2: prosljeujem iznimku." << endl;
		throw;
	}
	delete [] pok;
}

int main() {
	try {
		Func2();
	}
	catch(...) {
		cout << "Main: imam iznimku!" << endl;
	}

	char z;
	cin >> z;
	return 0;
}