//  linijetypeid.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 13.2: Operator typeid

#include <iostream>
#include <typeinfo>
using namespace std;

class Linija {
// ...
public:
	virtual void Crtaj() { cout << "Crtam Liniju" << endl; }
	// ...
};

class LinijaSaStrelicama : public Linija {
// ...
public:
	virtual void Crtaj() { cout << "Crtam Liniju sa strelicama" << endl; }
	// ...
};


int main() {

	Linija *niz[8];
	int duljNiza = 0;
	// inicijalizacija elemenata niza
	niz[duljNiza++] = new Linija;
	niz[duljNiza++] = new LinijaSaStrelicama;
	niz[duljNiza++] = new Linija;
	niz[duljNiza++] = new LinijaSaStrelicama;
	niz[duljNiza++] = new Linija;
	niz[duljNiza++] = new LinijaSaStrelicama;
	niz[duljNiza++] = new Linija;
	niz[duljNiza++] = new LinijaSaStrelicama;

	// crtanje samo linija
	int i;
	for (i = 0; i < duljNiza; i++) {
		if (typeid(*niz[i]) == typeid(LinijaSaStrelicama))
			niz[i]->Crtaj();
	}

	for (i = 0; i < duljNiza; i++)
		delete niz[i];
	char z;
	cin >> z;
	return 0;
}
