//  using.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 11.3.1 Deklaracija using

class B {
public:
	virtual void f(int);
	virtual void f(char);
	void g(int);
	void h(int);
};

class D : public B {
public:
	using B::f;
	void f(int);	// OK: D::f(int) e zaobii B::f(int)
	using B::g;
	void g(char);	// OK: ne postoji B::g(char)
	using B::h;
	void h(int);	// OK: D::h(int) e zaobii B::h(int)
};

void f(D* pd) {
	pd->f(1);		// poziva D::f(int)
	pd->f('a');		// poziva B::f(char)
	pd->g(1);		// poziva B::g(int)
	pd->g('a');		// poziva D::g(char)
	pd->h(1);		// poziva D::h(int)
}
