//  kompl.h

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 15.5: Organizacija predloaka

#include <iostream>
using namespace std;

template <class Prec>
class Kompleksni {
private:
	Prec re, im;
public:
	Kompleksni(Prec i = 0, Prec b = 0) : re(i), im(b) {}
	Prec DajRe();	// ovi lanovi namjerno nisu umetnuti
	Prec DajIm();	// kako bi se pokazala organizacija
	void PostaviReIm(Prec, Prec);
};

template <class Prec>
ostream &operator <<(ostream &, Kompleksni<Prec> &);


template <class Prec>
Prec Kompleksni<Prec>::DajRe() {
	return re;
}

template <class Prec>
Prec Kompleksni<Prec>::DajIm() {
	return im;
}

template <class Prec>
void Kompleksni<Prec>::PostaviReIm(Prec r, Prec i) {
	re = r; im = i;
}

template <class Prec>
ostream &operator <<(ostream &os, Kompleksni<Prec> &c) {
	os << c.DajRe();
	if (c.DajIm() >= 0) os << "+";
	os << c.DajIm() << "i";
	return os;
}
