//  is_custom.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 15.5.2: Uitavanje korisniki definiranih tipova

#include <iostream>
using namespace std;

class Kompleksni {
private:
	double realni, imaginarni;
public:
	Kompleksni(const double r = 0, const double i = 0) {
		realni = r;
		imaginarni = i;
	}
	double Re() {return realni;}
	double Im() {return imaginarni;}
	//...
};


istream& operator>>(istream &is, Kompleksni &z) {
	if (!is) return is;		// ako je tok ve u stanju
							// pogreke, operacija se prekida
	double r, i;			// realni i imaginarni dio
	char zn;				// za uitavanje predznaka
	int imPredznak = 1;		// predznak imaginarnog dijela
	is >> r >> zn;
	switch (zn) {
	  case '-':
		imPredznak = -1;
	  case '+':
		cin >> i >> zn;
		if (zn != 'i') {	// ako je prilikom unosa
							// detektirana pogreka
							// tok se postavlja u
							// stanje pogreke:
			is.clear(ios::failbit);
			return is;		// i operacija se prekida
		}
		break;
	}
	z = Kompleksni(r, i * imPredznak);
	return is;
}


int main() {

	Kompleksni z0;
	cin >> z0;

	return 0;
}