//  for_each.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Algoritmi i funkcijski objekti


#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

template <class T>
class zbroji {
private:
	T zbroj;
public:
	zbroji(T pocetnaVr = 0) : zbroj(pocetnaVr) { }
	void operator() (T vrijednost) { zbroj += vrijednost; }
	T AmoZbroj() const { return zbroj; }
};


int main() {
	vector<double> brojke;
	brojke.push_back(32423.4534);
	brojke.push_back(7834.62);

	zbroji<double> sigma;
	sigma = for_each(brojke.begin(), brojke.end(), sigma);

	cout << "Zbroj je: " << sigma.AmoZbroj() << endl;
	
	char z;
	cin >> z;
	return 0;
}

