//  iter_swap.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Algoritmi i funkcijski objekti


#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <ctime>
using namespace std;

int main() {

	vector<string> igraci;
	igraci.push_back(string("Dora"));
	igraci.push_back(string("Ivan"));
	igraci.push_back(string("Lucija"));
	igraci.push_back(string("Luka"));
	igraci.push_back(string("Marija"));
	igraci.push_back(string("Matej"));


	srand((unsigned)time(NULL));

	vector<string>::iterator prvi = igraci.begin();

	for (int i = 0; i < 10; i++) {
		vector<string>::iterator vadi = prvi + rand() % 6;
		vector<string>::iterator umetni = prvi + rand() % 6;
		if (vadi != umetni)
			iter_swap(vadi, umetni);
	}

	vector<string>::iterator zadnji = igraci.end();

	cout << "Konani redoslijed:" << endl;

	while (prvi != zadnji)
		cout << *prvi++ << endl;
	
	char z;
	cin >> z;
	return 0;
}

