//  negatori.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Funkcijski objekti - Negatori


#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <functional>
using namespace std;


int main() {

	vector<int> brojevi;
	brojevi.push_back(23);
	brojevi.push_back(3);
	brojevi.push_back(45);
	brojevi.push_back(27);
	brojevi.push_back(5);

	vector<int>::iterator prvi = brojevi.begin();
	vector<int>::iterator zadnji = brojevi.end();

	vector<int>::iterator nasao = find_if(prvi, zadnji, bind2nd(not2(less<int>()), 24));

	if (nasao != zadnji)
		cout << "Naao sam: " << *nasao << endl;
	else
		cout << "Nema takvog lana u popisu!" << endl;

	char z;
	cin >> z;
	return 0;
}

