//  iteratori_slucajni.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Algoritmi i funkcijski objekti - funkcijski objekt plus


#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>
using namespace std;

int main() {

	vector<int> v1;
	v1.push_back(1);
	v1.push_back(3);
	v1.push_back(5);
	v1.push_back(7);

	vector<int> v2;
	v2.push_back(2);
	v2.push_back(4);
	v2.push_back(6);
	v2.push_back(8);


	vector<int> zbroj(4);

	transform(v1.begin(), v1.end(), v2.begin(), zbroj.begin(), plus<int>());

	transform(v1.begin(), v1.end(), v2.begin(), back_inserter(zbroj), plus<int>());

	vector<int>::iterator prvi = zbroj.begin();
	vector<int>::iterator zadnji = zbroj.end();

	cout << "Zbroj vektora:" << endl;

	while (prvi != zadnji)
		cout << *prvi++ << endl;
	
	char z;
	cin >> z;
	return 0;
}

