//  queue.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Red


#include <iostream>
#include <queue>
#include <string>
using namespace std;


int main() {

	queue<string> poruke;

	// umetnimo tri elementa
	poruke.push("You say yes, ");
	poruke.push("I say no, ");
	poruke.push("You say stop ");

	// ispiimo prva dva elementa i maknimo ih iz reda:
	cout << poruke.front() << endl;
	poruke.pop();
	cout << poruke.front() << endl;
	poruke.pop();

	// dodajmo jo jedan element:
	poruke.push("and I say go.");

	// izvadimo element (bez ispisa):
	poruke.pop();

	// ispiimo jo jedan element i uklonimo ga: 
	cout << poruke.front() << endl;
	poruke.pop();

	if (!poruke.empty())
		cout << "U redu ima jo elemenata: " << poruke.size() << endl;
	else
		cout << "Red je prazan" << endl;

	char z;
	cin >> z;
	return 0;
}

