//  iteratori_slucajni.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Algoritmi i funkcijski objekti - Algoritmi koji mogu promijeniti redoslijed elemenata


#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;

int main() {

	vector<string> igraci;
	igraci.push_back(string("Dorotea"));
	igraci.push_back(string("Ivan"));
	igraci.push_back(string("Lucija"));
	igraci.push_back(string("Luka"));
	igraci.push_back(string("Marija"));
	igraci.push_back(string("Matej"));


	vector<string>::iterator prvi = igraci.begin();
	vector<string>::iterator zadnji = igraci.end();

	random_shuffle(prvi, zadnji);

	cout << "Konani redoslijed:" << endl;

	while (prvi != zadnji)
		cout << *prvi++ << endl;
	
	char z;
	cin >> z;
	return 0;
}

