//  set2.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Asocijativni spremnici


#include <iostream>
#include <set>
#include <string>
#include <locale>
using namespace std;


class CroManji {
public:
	bool operator() (const string &x, const string &y);
};

bool CroManji::operator() (const string &x, const string &y) {
	if (strcoll(x.c_str(), y.c_str()) < 0)
		return true;
	return false;
}


int main() {

	locale::locale("");

	set<string, CroManji> filmskiNaslovi;
	filmskiNaslovi.insert(string("Tko pjeva zlo ne misli"));
	filmskiNaslovi.insert(string("Selo moje malo"));
	filmskiNaslovi.insert(string("Diskretni arm buroazije"));
	filmskiNaslovi.insert(string("Maak Fritz"));
	filmskiNaslovi.insert(string("Arsen i stare ipke"));
	filmskiNaslovi.insert(string("Tko to tamo pjeva"));
	filmskiNaslovi.insert(string("M.A.S.H."));
	filmskiNaslovi.insert(string("ivot Briana"));
	filmskiNaslovi.insert(string("eks, lai i video trake"));

	// uzalud: pamti samo jednu vrijednost
	filmskiNaslovi.insert(string("M.A.S.H."));

	set<string, CroManji>::iterator prvi = filmskiNaslovi.begin();
	set<string, CroManji>::iterator zadnji = filmskiNaslovi.end();

	cout << "Evidencija:" << endl;

	while (prvi != zadnji) {
		cout << *prvi++ << endl;
	}

	char z;
	cin >> z;
	return 0;
}

