//  sort.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Algoritmi i funkcijski objekti


#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <ctime>
using namespace std;

int main() {

	vector<string> igraci;
	igraci.push_back(string("Dora"));
	igraci.push_back(string("Ivan"));
	igraci.push_back(string("Lucija"));
	igraci.push_back(string("Luka"));
	igraci.push_back(string("Marija"));
	igraci.push_back(string("Matej"));


	srand((unsigned)time(NULL));

	vector<string>::iterator prvi = igraci.begin();

	for (int i = 0; i < 10; i++) {
		vector<string>::iterator vadi = prvi + rand() % igraci.size();
		string selak(*vadi);		// ovaj e se preseliti
		igraci.erase(vadi);
		vector<string>::iterator metni = prvi + rand() % igraci.size();
		if (vadi < metni)
			cout << selak << " ide prema poetku." << endl;
		else
			cout << selak << " ide prema kraju." << endl;
		igraci.insert(metni, selak);
	}

	vector<string>::iterator zadnji = igraci.end();

	cout << "Redoslijed nakon mijeanja:" << endl;

	while (prvi != zadnji)
		cout << *prvi++ << endl;

	sort(igraci.begin(), igraci.end());

	prvi = igraci.begin();

	cout << "Redoslijed nakon sortiranja:" << endl;

	while (prvi != zadnji)
		cout << *prvi++ << endl;

	char z;
	cin >> z;
	return 0;
}

