//  stack.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Stog


#include <iostream>
#include <stack>
#include <string>
using namespace std;




int main() {

	typedef pair<string, string> karta;

	stack<karta> talon;
	talon.push(karta("9", "herc"));
	talon.push(karta("A", "pik"));
	talon.push(karta("Q", "tref"));

	// ispiimo kartu na vrhu:
	cout << talon.top().first << " " << talon.top().second << endl;

	// izvadimo kartu s vrha:
	talon.pop();

	// ispiimo kartu na vrhu:
	cout << talon.top().first << " " << talon.top().second << endl;

	// zamijenimo kartu na vrku:
	talon.top() = karta("K", "karo");

	// ispiimo kartu na vrhu:
	cout << talon.top().first << " " << talon.top().second << endl;

	char z;
	cin >> z;
	return 0;
}

